import java.util.*;
import java.io.*;

public class FBook {

    private ArrayList<Person> members;

    public FBook(){
	members = new ArrayList<Person>();
    }

    public void addMembers(String namesFile) throws IOException {
	Scanner sc = new Scanner(new File(namesFile));
	while (sc.hasNext()) add(sc.next());
	sc.close();
    }
    //
    // namesFile is name of a file of names of people
    //

    private void add(String name){members.add(new Person(name));}
    //
    // add a person to FBook
    //

    public void addFriends(String friendsFile) throws IOException {
	Scanner sc = new Scanner(new File(friendsFile));
	while (sc.hasNext()) makeFriends(find(sc.next()),find(sc.next()));
	sc.close();
    }

    private static int binSearch(String name,ArrayList<Person> data,int low,int high){
	if (low > high) return -1;
	int mid = (low + high) / 2;
	int c   = name.compareTo(data.get(mid).getName());
	if (c < 0) return binSearch(name,data,low,mid-1);
	else if (c == 0) return mid;
	else return binSearch(name,data,mid+1,high);
    }
    //
    // returns the location of the person with given name
    //

    public Person find(String name){
	int i = binSearch(name,members,0,members.size()-1);
	if (i == -1) return null;
	return members.get(i);
    }
    //
    // IMPLEMENT THIS
    // find, and return, the Person with this
    // name or null if not present
    //

     private void makeFriends(Person p1,Person p2){
	 p1.addFriend(p2);
	 p2.addFriend(p1);
     }
    //
    // IMPLEMENT THIS
    // make person p1 and person p2 friends
    //

    public boolean areFriends(Person p1,Person p2){
	if (p1 == null || p2 == null) return false;
	for (Person p : p1.getFriends()) if (p == p2) return true;
	return false;
    }
    //
    // IMPLEMENT THIS
    // given two people, are they friends?
    //

    public ArrayList<Person> commonFriends(Person p1,Person p2){
	if (p1 == null || p2 == null) return null;
	ArrayList<Person> cf = new ArrayList<Person>();
	for (Person p : p1.getFriends()) if (areFriends(p,p2)) cf.add(p);
	return cf;
    }
    //
    // IMPLEMENT THIS
    // return the friends shared by two people
    //

    public Person leastPopular(){
	int popularity = members.size()+1; 
	Person leastPopular = null;
	int size;
	for (Person p : members){
	    size = p.getFriends().size();
	    if (size < popularity){popularity = size; leastPopular = p;}
	}
	return leastPopular;
    }
    //
    // IMPLEMENT THIS
    // find the least popular repson
    //

    public Person mostPopular(){
	int popularity = -1;
	Person mostPopular = null;
	int size;
	for (Person p : members){
	    size = p.getFriends().size();
	    if (size > popularity){popularity = size; mostPopular = p;}
	}
	return mostPopular;
    }
    //
    // find the most popular person
    //

    public int avgPopularity(){
	int sum = 0;
	for (Person p : members) sum = sum + p.getFriends().size();
	return sum / members.size();
    }
    //
    // IMPLEMENT THIS
    // return the average popularity
    //

    public int size(){
	return members.size();
    }
    //
    // IMPLEMENT THIS
    // return the number of people in FBook
    //
}
